package visiteurs;

import parser.*;
import parser.treesParser.*;
import arbre.*;


public class AntlrToAst extends treesBaseVisitor<Noeud>{
	//on n’implémente pas directement l’interface, on utilise
	//plutôt une extension pour bénéficier de certains trucs déjà
	//codés dans le code généré (pour certaines erreurs notamment)
	//
	//En effet, l’interface seule est déjà une extension.
	//

	public Noeud visitBranche(BrancheContext bc){
		Noeud g = bc.tree_int(0).accept(this);
		Noeud d = bc.tree_int(1).accept(this);
		return new Branche(g,d);

	}
	public Noeud visitFeuille(FeuilleContext fc){
		int n = Integer.parseInt(
				fc	
				.Int()		//méthode du parser
				.getText()	//retourne la chaîne de caractères associée à un lexème (cf doc java pour Antlr)	
				);
		return new Feuille(n);
	}
	public Noeud visitPar(ParContext pc){
		Tree_intContext tree = pc.tree_int();
		return tree.accept(this);
	}

}
